"use strict";

var _interopRequireWildcard = require("reshow-runtime/helpers/interopRequireWildcard");

var _interopRequireDefault = require("reshow-runtime/helpers/interopRequireDefault");

var _classCallCheck2 = _interopRequireDefault(require("reshow-runtime/helpers/classCallCheck"));

var _createClass2 = _interopRequireDefault(require("reshow-runtime/helpers/createClass"));

var _possibleConstructorReturn2 = _interopRequireDefault(require("reshow-runtime/helpers/possibleConstructorReturn"));

var _getPrototypeOf2 = _interopRequireDefault(require("reshow-runtime/helpers/getPrototypeOf"));

var _inherits2 = _interopRequireDefault(require("reshow-runtime/helpers/inherits"));

var _react = _interopRequireWildcard(require("react"));

var _index = require("../../../src/index");

var _chai = require("chai");

var _enzyme = require("enzyme");

var _enzymeAdapterReact = _interopRequireDefault(require("enzyme-adapter-react-16"));

(0, _enzyme.configure)({
  adapter: new _enzymeAdapterReact["default"]()
});

var _ref =
/*#__PURE__*/
_react["default"].createElement("div", null);

describe('Test RealTimeReturn', function () {
  var TestEl =
  /*#__PURE__*/
  function (_PureComponent) {
    (0, _inherits2["default"])(TestEl, _PureComponent);

    function TestEl() {
      (0, _classCallCheck2["default"])(this, TestEl);
      return (0, _possibleConstructorReturn2["default"])(this, (0, _getPrototypeOf2["default"])(TestEl).apply(this, arguments));
    }

    (0, _createClass2["default"])(TestEl, [{
      key: "render",
      value: function render() {
        return _ref;
      }
    }]);
    return TestEl;
  }(_react.PureComponent);

  var FakeComponent =
  /*#__PURE__*/
  function (_PureComponent2) {
    (0, _inherits2["default"])(FakeComponent, _PureComponent2);

    function FakeComponent() {
      (0, _classCallCheck2["default"])(this, FakeComponent);
      return (0, _possibleConstructorReturn2["default"])(this, (0, _getPrototypeOf2["default"])(FakeComponent).apply(this, arguments));
    }

    (0, _createClass2["default"])(FakeComponent, [{
      key: "render",
      value: function render() {
        var _this = this;

        var realTimeReset = this.props.realTimeReset;
        return _react["default"].createElement(_index.RealTimeReturn, {
          realTimeReset: realTimeReset,
          realTimePath: ['r']
        }, _react["default"].createElement(TestEl, {
          ref: function ref(el) {
            return _this.el = el;
          }
        }));
      }
    }]);
    return FakeComponent;
  }(_react.PureComponent);

  var uWrap;
  afterEach(function () {
    uWrap.unmount();
  });

  var _ref2 =
  /*#__PURE__*/
  _react["default"].createElement(FakeComponent, null);

  it('dispatch pageStore first', function () {
    var vDom = _ref2;
    uWrap = (0, _enzyme.mount)(vDom);
    var uFake = uWrap.instance();
    (0, _index.dispatch)({
      data: 'foo'
    });
    (0, _chai.expect)(uFake.el.props.data).to.equal('foo');
    (0, _index.dispatch)({
      type: 'realTime',
      params: {
        r: {
          data: 'bar'
        }
      }
    });
    (0, _chai.expect)(uFake.el.props.data).to.equal('bar');
  });

  var _ref3 =
  /*#__PURE__*/
  _react["default"].createElement(FakeComponent, null);

  it('dispatch realtime first', function () {
    var vDom = _ref3;
    uWrap = (0, _enzyme.mount)(vDom);
    var uFake = uWrap.instance();
    (0, _index.dispatch)({
      type: 'realTime',
      params: {
        r: {
          data: 'bar'
        }
      }
    });
    (0, _chai.expect)(uFake.el.props.data).to.equal('bar');
    (0, _index.dispatch)({
      data: 'foo'
    });
    (0, _chai.expect)(uFake.el.props.data).to.equal('bar');
  });

  var _ref4 =
  /*#__PURE__*/
  _react["default"].createElement(FakeComponent, {
    realTimeReset: true
  });

  it('test realtime reset', function () {
    var vDom = _ref4;
    uWrap = (0, _enzyme.mount)(vDom);
    var uFake = uWrap.instance();
    (0, _index.dispatch)({
      type: 'realTime',
      params: {
        r: {
          data: 'bar'
        }
      }
    });
    (0, _chai.expect)(uFake.el.props.data).to.equal('bar');
    (0, _index.dispatch)({
      data: 'foo'
    });
    (0, _chai.expect)(uFake.el.props.data).to.be["null"];
  });
});