"use strict";

var _interopRequireWildcard = require("reshow-runtime/helpers/interopRequireWildcard");

var _interopRequireDefault = require("reshow-runtime/helpers/interopRequireDefault");

var _defineProperty2 = _interopRequireDefault(require("reshow-runtime/helpers/defineProperty"));

var _classCallCheck2 = _interopRequireDefault(require("reshow-runtime/helpers/classCallCheck"));

var _createClass2 = _interopRequireDefault(require("reshow-runtime/helpers/createClass"));

var _possibleConstructorReturn2 = _interopRequireDefault(require("reshow-runtime/helpers/possibleConstructorReturn"));

var _getPrototypeOf2 = _interopRequireDefault(require("reshow-runtime/helpers/getPrototypeOf"));

var _inherits2 = _interopRequireDefault(require("reshow-runtime/helpers/inherits"));

var _react = _interopRequireWildcard(require("react"));

var _index = require("../../../src/index");

var _chai = require("chai");

var _enzyme = require("enzyme");

var _enzymeAdapterReact = _interopRequireDefault(require("enzyme-adapter-react-16"));

(0, _enzyme.configure)({
  adapter: new _enzymeAdapterReact["default"]()
});

var _ref =
/*#__PURE__*/
_react["default"].createElement("div", null);

describe('Test Section', function () {
  var TestEl =
  /*#__PURE__*/
  function (_PureComponent) {
    (0, _inherits2["default"])(TestEl, _PureComponent);

    function TestEl() {
      (0, _classCallCheck2["default"])(this, TestEl);
      return (0, _possibleConstructorReturn2["default"])(this, (0, _getPrototypeOf2["default"])(TestEl).apply(this, arguments));
    }

    (0, _createClass2["default"])(TestEl, [{
      key: "render",
      value: function render() {
        return _ref;
      }
    }]);
    return TestEl;
  }(_react.PureComponent);

  var FakeComponent =
  /*#__PURE__*/
  function (_PureComponent2) {
    (0, _inherits2["default"])(FakeComponent, _PureComponent2);

    function FakeComponent() {
      (0, _classCallCheck2["default"])(this, FakeComponent);
      return (0, _possibleConstructorReturn2["default"])(this, (0, _getPrototypeOf2["default"])(FakeComponent).apply(this, arguments));
    }

    (0, _createClass2["default"])(FakeComponent, [{
      key: "render",
      value: function render() {
        var _this = this;

        var _this$props = this.props,
            immutable = _this$props.immutable,
            name = _this$props.name;
        return _react["default"].createElement(_index.Section, {
          name: name,
          immutable: immutable
        }, _react["default"].createElement(TestEl, {
          ref: function ref(el) {
            return _this.el = el;
          }
        }));
      }
    }]);
    return FakeComponent;
  }(_react.PureComponent);

  (0, _defineProperty2["default"])(FakeComponent, "defaultProps", {
    name: 'test'
  });
  beforeEach(function () {
    return (0, _index.dispatch)('config/reset');
  });

  var _ref2 =
  /*#__PURE__*/
  _react["default"].createElement(FakeComponent, null);

  it('Section is existed', function () {
    var vDom = _ref2;
    var uFake = (0, _enzyme.mount)(vDom).instance();
    (0, _index.dispatch)({
      section: {
        test: {
          shouldRender: true,
          aaa: {
            bbb: 'ccc'
          }
        }
      },
      I18N: {
        ddd: 'fff'
      }
    });
    (0, _chai.expect)(uFake.el.props.aaa).to.deep.equal({
      bbb: 'ccc'
    });
    (0, _chai.expect)(uFake.el.props.I18N).to.deep.equal({
      ddd: 'fff'
    });
  });

  var _ref3 =
  /*#__PURE__*/
  _react["default"].createElement(FakeComponent, {
    name: "xxx"
  });

  it('Section is not existed', function () {
    var vDom = _ref3;
    var uFake = (0, _enzyme.mount)(vDom).instance();
    (0, _index.dispatch)({
      section: null
    });
    (0, _chai.expect)('undefined' === typeof uFake.el).to.be["true"];
  });

  var _ref4 =
  /*#__PURE__*/
  _react["default"].createElement(FakeComponent, {
    immutable: true
  });

  it('Section is existed with immutable', function () {
    var vDom = _ref4;
    var uFake = (0, _enzyme.mount)(vDom).instance();
    (0, _index.dispatch)({
      section: {
        test: {
          shouldRender: true,
          aaa: {
            bbb: 'ccc'
          }
        }
      },
      I18N: {
        ddd: 'fff'
      }
    });
    (0, _chai.expect)(uFake.el.props.aaa.toJS()).to.deep.equal({
      bbb: 'ccc'
    });
    (0, _chai.expect)(uFake.el.props.I18N.toJS()).to.deep.equal({
      ddd: 'fff'
    });
  });

  var _ref5 =
  /*#__PURE__*/
  _react["default"].createElement(FakeComponent, {
    name: "xxx",
    immutable: true
  });

  it('Section is not existed with immutable', function () {
    var vDom = _ref5;
    var uFake = (0, _enzyme.mount)(vDom).instance();
    (0, _index.dispatch)({
      section: null
    });
    (0, _chai.expect)('undefined' === typeof uFake.el).to.be["true"];
  });
});