import _classCallCheck from "reshow-runtime/es/helpers/classCallCheck";
import _createClass from "reshow-runtime/es/helpers/createClass";
import _possibleConstructorReturn from "reshow-runtime/es/helpers/possibleConstructorReturn";
import _getPrototypeOf from "reshow-runtime/es/helpers/getPrototypeOf";
import _assertThisInitialized from "reshow-runtime/es/helpers/assertThisInitialized";
import _inherits from "reshow-runtime/es/helpers/inherits";
import _defineProperty from "reshow-runtime/es/helpers/defineProperty";
import _typeof from "reshow-runtime/es/helpers/typeof";
import { ReduceStore } from 'reshow-flux';
import { Map, List } from 'immutable';
import get from 'get-object-value';
import callfunc from 'call-func';
import dispatcher, { dispatch } from '../dispatcher';
var alertCount = 0;
var isArray = Array.isArray;

var toMessage = function toMessage(message) {
  if (-1 !== 'string|number'.indexOf(_typeof(message))) {
    message = {
      message: message
    };
  }

  if (!message.id) {
    message.id = 'm-' + alertCount;
    alertCount++;
  }

  return message;
};

var getMessage = function getMessage(action) {
  return toMessage(get(action, ['params', 'message']));
};

var MessageStore =
/*#__PURE__*/
function (_ReduceStore) {
  _inherits(MessageStore, _ReduceStore);

  function MessageStore() {
    var _getPrototypeOf2;

    var _this;

    _classCallCheck(this, MessageStore);

    for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    _this = _possibleConstructorReturn(this, (_getPrototypeOf2 = _getPrototypeOf(MessageStore)).call.apply(_getPrototypeOf2, [this].concat(args)));

    _defineProperty(_assertThisInitialized(_this), "dialogCallback", null);

    return _this;
  }

  _createClass(MessageStore, [{
    key: "getInitialState",
    value: function getInitialState() {
      return Map({
        alerts: List()
      });
    }
  }, {
    key: "dialogStart",
    value: function dialogStart(state, action) {
      var params = get(action, ['params']);
      var dialog = params.dialog,
          dialogProps = params.dialogProps,
          dialogTo = params.dialogTo,
          callback = params.callback;
      var next = {
        dialog: dialog
      };

      if (dialogProps) {
        next.dialogProps = dialogProps;
      }

      if (dialogTo) {
        next.dialogTo = dialogTo;
      }

      if (callback) {
        this.dialogCallback = callback;
      }

      return state.merge(next);
    }
  }, {
    key: "dialogEnd",
    value: function dialogEnd(state, action) {
      var dialogTo = state.get('dialogTo');

      if (!dialogTo) {
        dialogTo = 'dialogReturn';
      }

      var value = get(action, ['params', 'item', 'props', 'value']);
      dispatch(_defineProperty({}, dialogTo, value));
      callfunc(this.dialogCallback, [value]);
      this.dialogCallback = null;
      return state["delete"]('dialog')["delete"]('dialogProps')["delete"]('dialogTo');
    }
  }, {
    key: "alertReset",
    value: function alertReset(state, action) {
      var alerts = get(action, ['params', 'alerts']);

      if (!isArray(alerts)) {
        alerts = List();
      } else {
        alerts = List(alerts.map(function (a) {
          return toMessage(a);
        }));
      }

      return state.set('alerts', alerts);
    }
  }, {
    key: "alertDel",
    value: function alertDel(state, action) {
      var id = get(action, ['params', 'id']);
      var alerts = state.get('alerts').filter(function (item) {
        return item.id !== id ? true : false;
      });
      return state.set('alerts', alerts);
    }
  }, {
    key: "alertAdd",
    value: function alertAdd(state, action) {
      var alerts = state.get('alerts');
      var message = getMessage(action);
      var alertProps = get(action, ['params', 'alertProps']);

      if (alertProps) {
        state = state.set('alertProps', alertProps);
      }

      return state.set('alerts', alerts.push(message));
    }
  }, {
    key: "reduce",
    value: function reduce(state, action) {
      switch (action.type) {
        case 'dialog/start':
          return this.dialogStart(state, action);

        case 'dialog/end':
          return this.dialogEnd(state, action);

        case 'alert/reset':
          return this.alertReset(state, action);

        case 'alert/del':
          return this.alertDel(state, action);

        case 'alert/add':
          return this.alertAdd(state, action);

        default:
          return state;
      }
    }
  }]);

  return MessageStore;
}(ReduceStore); // Export a singleton instance of the store


export default new MessageStore(dispatcher);