import _objectWithoutProperties from "reshow-runtime/es/helpers/objectWithoutProperties";
import _objectSpread from "reshow-runtime/es/helpers/objectSpread2";
import React, { PureComponent } from 'react';
import get from 'get-object-value';
import { connectHook } from 'reshow-flux';
import { build } from 'react-atomic-molecule';
import { returnOptions, Return } from '../molecules/ReshowComponent';
import realTimeStore from '../../src/stores/realTimeStore';
var REAL_TIME_KEY = '--realTimeData--';
var REAL_TIME_URL = '--realTimeUrl--';
var keys = Object.keys;

var getStores = function getStores(props) {
  return props.stores || [realTimeStore];
};

var calculateState = function calculateState(prevState, props) {
  var realTimeState = realTimeStore.getState();
  var path = props.realTimePath,
      url = props.realTimeUrl,
      realTimeReset = props.realTimeReset;
  var data = get(realTimeState, path);
  var wsUrl = get(realTimeState, [REAL_TIME_URL]);

  if (data && (!url || url === wsUrl)) {
    data[REAL_TIME_URL] = wsUrl;
    return data;
  } else {
    if (realTimeReset) {
      // Reset for when reconnection to new websocket server
      // will not send duplicate data to client
      var reset = {};
      keys(prevState).forEach(function (key) {
        return reset[key] = null;
      });
      return reset;
    }
  }
};

var defaultProps = _objectSpread({}, returnOptions.defaultProps, {
  realTimePath: [REAL_TIME_KEY],
  realTimeUrl: null,
  realTimeReset: false
});

var myReturnOptions = _objectSpread({}, returnOptions, {
  getStores: getStores,
  calculateState: calculateState,
  defaultProps: defaultProps
});

var RealTimeReturn = function RealTimeReturn(props) {
  var children = props.children,
      realTimePath = props.realTimePath,
      otherProps = _objectWithoutProperties(props, ["children", "realTimePath"]);

  var myOtherProps = returnOptions.reset(otherProps);
  return React.createElement(Return, null, function (pageState) {
    return build(children)(_objectSpread({}, pageState, {}, myOtherProps));
  });
};

export default connectHook(RealTimeReturn, myReturnOptions);