import _objectSpread from "reshow-runtime/es/helpers/objectSpread2";
import _classCallCheck from "reshow-runtime/es/helpers/classCallCheck";
import _createClass from "reshow-runtime/es/helpers/createClass";
import _possibleConstructorReturn from "reshow-runtime/es/helpers/possibleConstructorReturn";
import _getPrototypeOf from "reshow-runtime/es/helpers/getPrototypeOf";
import _assertThisInitialized from "reshow-runtime/es/helpers/assertThisInitialized";
import _inherits from "reshow-runtime/es/helpers/inherits";
import _defineProperty from "reshow-runtime/es/helpers/defineProperty";
import React, { PureComponent, memo } from 'react';
import { AlertsNotifier, Dialog, DisplayPopupEl } from 'organism-react-popup';
import { build, SemanticUI } from 'react-atomic-molecule';
import { toJS } from 'reshow-return';
import { Return } from '../molecules/ReshowComponent'; // src

import messageStore from '../../src/stores/messageStore';
import { dispatch } from '../../src/index';

var Body =
/*#__PURE__*/
function (_PureComponent) {
  _inherits(Body, _PureComponent);

  function Body() {
    var _getPrototypeOf2;

    var _this;

    _classCallCheck(this, Body);

    for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    _this = _possibleConstructorReturn(this, (_getPrototypeOf2 = _getPrototypeOf(Body)).call.apply(_getPrototypeOf2, [this].concat(args)));

    _defineProperty(_assertThisInitialized(_this), "handleDismiss", function (item) {
      dispatch('alert/del', {
        id: item.id
      });
    });

    _defineProperty(_assertThisInitialized(_this), "handleClick", function (e, item) {
      setTimeout(function () {
        var dialog = _this.props.dialog;

        if (dialog) {
          dispatch('dialog/end', {
            item: item
          });
        }
      });
    });

    return _this;
  }

  _createClass(Body, [{
    key: "render",
    value: function render() {
      var _this$props = this.props,
          defaultAlertProps = _this$props.defaultAlertProps,
          defaultDialogProps = _this$props.defaultDialogProps,
          alerts = _this$props.alerts,
          alertProps = _this$props.alertProps,
          alertComponent = _this$props.alertComponent,
          dialog = _this$props.dialog,
          dialogProps = _this$props.dialogProps,
          dialogComponent = _this$props.dialogComponent;
      var thisDialog = null;

      if (dialog) {
        thisDialog = React.createElement(DisplayPopupEl, null, build(dialogComponent)(_objectSpread({}, defaultDialogProps, {}, toJS(dialogProps), {
          onClick: this.handleClick,
          onClose: this.handleClick
        }), toJS(dialog)));
      }

      return React.createElement(SemanticUI, null, thisDialog, build(alertComponent)(_objectSpread({}, defaultAlertProps, {}, toJS(alertProps), {
        onDismiss: this.handleDismiss,
        alerts: toJS(alerts)
      })));
    }
  }]);

  return Body;
}(PureComponent);

_defineProperty(Body, "defaultProps", {
  dialogComponent: Dialog,
  alertComponent: AlertsNotifier
});

var ReshowMessage = memo(function (props) {
  return React.createElement(Return, {
    stores: [messageStore],
    initStates: ['alerts', 'alertProps', 'dialog', 'dialogProps']
  }, React.createElement(Body, props));
});
ReshowMessage.displayName = 'ReshowMessage';
export default ReshowMessage;