import _classCallCheck from "reshow-runtime/es/helpers/classCallCheck";
import _createClass from "reshow-runtime/es/helpers/createClass";
import _possibleConstructorReturn from "reshow-runtime/es/helpers/possibleConstructorReturn";
import _getPrototypeOf from "reshow-runtime/es/helpers/getPrototypeOf";
import _inherits from "reshow-runtime/es/helpers/inherits";
import React, { PureComponent } from 'react';
import { RealTimeReturn, dispatch } from '../../../src/index';
import { expect } from 'chai';
import { shallow, mount, configure } from 'enzyme';
import Adapter from 'enzyme-adapter-react-16';
configure({
  adapter: new Adapter()
});

var _ref =
/*#__PURE__*/
React.createElement("div", null);

describe('Test RealTimeReturn', function () {
  var TestEl =
  /*#__PURE__*/
  function (_PureComponent) {
    _inherits(TestEl, _PureComponent);

    function TestEl() {
      _classCallCheck(this, TestEl);

      return _possibleConstructorReturn(this, _getPrototypeOf(TestEl).apply(this, arguments));
    }

    _createClass(TestEl, [{
      key: "render",
      value: function render() {
        return _ref;
      }
    }]);

    return TestEl;
  }(PureComponent);

  var FakeComponent =
  /*#__PURE__*/
  function (_PureComponent2) {
    _inherits(FakeComponent, _PureComponent2);

    function FakeComponent() {
      _classCallCheck(this, FakeComponent);

      return _possibleConstructorReturn(this, _getPrototypeOf(FakeComponent).apply(this, arguments));
    }

    _createClass(FakeComponent, [{
      key: "render",
      value: function render() {
        var _this = this;

        var realTimeReset = this.props.realTimeReset;
        return React.createElement(RealTimeReturn, {
          realTimeReset: realTimeReset,
          realTimePath: ['r']
        }, React.createElement(TestEl, {
          ref: function ref(el) {
            return _this.el = el;
          }
        }));
      }
    }]);

    return FakeComponent;
  }(PureComponent);

  var uWrap;
  afterEach(function () {
    uWrap.unmount();
  });

  var _ref2 =
  /*#__PURE__*/
  React.createElement(FakeComponent, null);

  it('dispatch pageStore first', function () {
    var vDom = _ref2;
    uWrap = mount(vDom);
    var uFake = uWrap.instance();
    dispatch({
      data: 'foo'
    });
    expect(uFake.el.props.data).to.equal('foo');
    dispatch({
      type: 'realTime',
      params: {
        r: {
          data: 'bar'
        }
      }
    });
    expect(uFake.el.props.data).to.equal('bar');
  });

  var _ref3 =
  /*#__PURE__*/
  React.createElement(FakeComponent, null);

  it('dispatch realtime first', function () {
    var vDom = _ref3;
    uWrap = mount(vDom);
    var uFake = uWrap.instance();
    dispatch({
      type: 'realTime',
      params: {
        r: {
          data: 'bar'
        }
      }
    });
    expect(uFake.el.props.data).to.equal('bar');
    dispatch({
      data: 'foo'
    });
    expect(uFake.el.props.data).to.equal('bar');
  });

  var _ref4 =
  /*#__PURE__*/
  React.createElement(FakeComponent, {
    realTimeReset: true
  });

  it('test realtime reset', function () {
    var vDom = _ref4;
    uWrap = mount(vDom);
    var uFake = uWrap.instance();
    dispatch({
      type: 'realTime',
      params: {
        r: {
          data: 'bar'
        }
      }
    });
    expect(uFake.el.props.data).to.equal('bar');
    dispatch({
      data: 'foo'
    });
    expect(uFake.el.props.data).to.be["null"];
  });
});