import _defineProperty from "reshow-runtime/es/helpers/defineProperty";
import _classCallCheck from "reshow-runtime/es/helpers/classCallCheck";
import _createClass from "reshow-runtime/es/helpers/createClass";
import _possibleConstructorReturn from "reshow-runtime/es/helpers/possibleConstructorReturn";
import _getPrototypeOf from "reshow-runtime/es/helpers/getPrototypeOf";
import _inherits from "reshow-runtime/es/helpers/inherits";
import React, { PureComponent } from 'react';
import { Section, dispatch } from '../../../src/index';
import { expect } from 'chai';
import { shallow, mount, configure } from 'enzyme';
import Adapter from 'enzyme-adapter-react-16';
configure({
  adapter: new Adapter()
});

var _ref =
/*#__PURE__*/
React.createElement("div", null);

describe('Test Section', function () {
  var TestEl =
  /*#__PURE__*/
  function (_PureComponent) {
    _inherits(TestEl, _PureComponent);

    function TestEl() {
      _classCallCheck(this, TestEl);

      return _possibleConstructorReturn(this, _getPrototypeOf(TestEl).apply(this, arguments));
    }

    _createClass(TestEl, [{
      key: "render",
      value: function render() {
        return _ref;
      }
    }]);

    return TestEl;
  }(PureComponent);

  var FakeComponent =
  /*#__PURE__*/
  function (_PureComponent2) {
    _inherits(FakeComponent, _PureComponent2);

    function FakeComponent() {
      _classCallCheck(this, FakeComponent);

      return _possibleConstructorReturn(this, _getPrototypeOf(FakeComponent).apply(this, arguments));
    }

    _createClass(FakeComponent, [{
      key: "render",
      value: function render() {
        var _this = this;

        var _this$props = this.props,
            immutable = _this$props.immutable,
            name = _this$props.name;
        return React.createElement(Section, {
          name: name,
          immutable: immutable
        }, React.createElement(TestEl, {
          ref: function ref(el) {
            return _this.el = el;
          }
        }));
      }
    }]);

    return FakeComponent;
  }(PureComponent);

  _defineProperty(FakeComponent, "defaultProps", {
    name: 'test'
  });

  beforeEach(function () {
    return dispatch('config/reset');
  });

  var _ref2 =
  /*#__PURE__*/
  React.createElement(FakeComponent, null);

  it('Section is existed', function () {
    var vDom = _ref2;
    var uFake = mount(vDom).instance();
    dispatch({
      section: {
        test: {
          shouldRender: true,
          aaa: {
            bbb: 'ccc'
          }
        }
      },
      I18N: {
        ddd: 'fff'
      }
    });
    expect(uFake.el.props.aaa).to.deep.equal({
      bbb: 'ccc'
    });
    expect(uFake.el.props.I18N).to.deep.equal({
      ddd: 'fff'
    });
  });

  var _ref3 =
  /*#__PURE__*/
  React.createElement(FakeComponent, {
    name: "xxx"
  });

  it('Section is not existed', function () {
    var vDom = _ref3;
    var uFake = mount(vDom).instance();
    dispatch({
      section: null
    });
    expect('undefined' === typeof uFake.el).to.be["true"];
  });

  var _ref4 =
  /*#__PURE__*/
  React.createElement(FakeComponent, {
    immutable: true
  });

  it('Section is existed with immutable', function () {
    var vDom = _ref4;
    var uFake = mount(vDom).instance();
    dispatch({
      section: {
        test: {
          shouldRender: true,
          aaa: {
            bbb: 'ccc'
          }
        }
      },
      I18N: {
        ddd: 'fff'
      }
    });
    expect(uFake.el.props.aaa.toJS()).to.deep.equal({
      bbb: 'ccc'
    });
    expect(uFake.el.props.I18N.toJS()).to.deep.equal({
      ddd: 'fff'
    });
  });

  var _ref5 =
  /*#__PURE__*/
  React.createElement(FakeComponent, {
    name: "xxx",
    immutable: true
  });

  it('Section is not existed with immutable', function () {
    var vDom = _ref5;
    var uFake = mount(vDom).instance();
    dispatch({
      section: null
    });
    expect('undefined' === typeof uFake.el).to.be["true"];
  });
});