import _classCallCheck from "reshow-runtime/es/helpers/classCallCheck";
import _createClass from "reshow-runtime/es/helpers/createClass";
import _possibleConstructorReturn from "reshow-runtime/es/helpers/possibleConstructorReturn";
import _getPrototypeOf from "reshow-runtime/es/helpers/getPrototypeOf";
import _assertThisInitialized from "reshow-runtime/es/helpers/assertThisInitialized";
import _inherits from "reshow-runtime/es/helpers/inherits";
import _defineProperty from "reshow-runtime/es/helpers/defineProperty";
import React, { PureComponent } from 'react';
import { Return, localStorageStore, sessionStorageStore, storageDispatch } from '../../../src/index';
import { expect } from 'chai';
import { shallow, mount, configure } from 'enzyme';
import Adapter from 'enzyme-adapter-react-16';
configure({
  adapter: new Adapter()
});

var _ref =
/*#__PURE__*/
React.createElement("div", null);

describe('Test Storage Return', function () {
  var TestEl =
  /*#__PURE__*/
  function (_PureComponent) {
    _inherits(TestEl, _PureComponent);

    function TestEl() {
      var _getPrototypeOf2;

      var _this;

      _classCallCheck(this, TestEl);

      for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
        args[_key] = arguments[_key];
      }

      _this = _possibleConstructorReturn(this, (_getPrototypeOf2 = _getPrototypeOf(TestEl)).call.apply(_getPrototypeOf2, [this].concat(args)));

      _defineProperty(_assertThisInitialized(_this), "show", 0);

      return _this;
    }

    _createClass(TestEl, [{
      key: "render",
      value: function render() {
        this.show++;
        return _ref;
      }
    }]);

    return TestEl;
  }(PureComponent);

  var FakeComponent =
  /*#__PURE__*/
  function (_PureComponent2) {
    _inherits(FakeComponent, _PureComponent2);

    function FakeComponent() {
      _classCallCheck(this, FakeComponent);

      return _possibleConstructorReturn(this, _getPrototypeOf(FakeComponent).apply(this, arguments));
    }

    _createClass(FakeComponent, [{
      key: "render",
      value: function render() {
        var _this2 = this;

        var storage = this.props.storage;
        return React.createElement(Return, {
          stores: [storage]
        }, React.createElement(TestEl, {
          ref: function ref(el) {
            return _this2.el = el;
          }
        }));
      }
    }]);

    return FakeComponent;
  }(PureComponent);

  var _ref2 =
  /*#__PURE__*/
  React.createElement(FakeComponent, {
    storage: localStorageStore
  });

  it('test get local storage', function () {
    var vDom = _ref2;
    var uFake = mount(vDom).instance();
    var uString = 'test123';
    storageDispatch('local', {
      data: uString
    });
    expect(uFake.el.props.data).to.equal(uString);
  });

  var _ref3 =
  /*#__PURE__*/
  React.createElement(FakeComponent, {
    storage: sessionStorageStore
  });

  it('test get session storage', function () {
    var vDom = _ref3;
    var uFake = mount(vDom).instance();
    var uString = 'test456';
    storageDispatch('session', {
      data: uString
    });
    expect(uFake.el.props.data).to.equal(uString);
  });
});